/*
 * CreateAcceptedTaxonID.java
 *
 * Created on 28. Juni 2004, 10:19
 */

package net.metadiversity.diversity.navigator.db.diversity_names_lias;

import java.lang.Integer;

/**
 *
 * @author  didi
 */
public class CreateAcceptedTaxonID
{
    java.lang.String db_url     = "jdbc:postgresql://hongkong.didi.dn:5432/derek";
    java.lang.String db_user    = "didi";
    java.lang.String db_pwd     = "";
    java.lang.String db_driver  = "org.postgresql.Driver";
    
    String databaseTable = "checklists_data";    
    String sql;
    
    java.util.Vector idVector;
    java.util.Vector acceptedIdVector;
    
    /** Creates a new instance of CreateAcceptedTaxonID */
    public CreateAcceptedTaxonID()
    {
        sql = "SELECT id, \"ChecklistId\", \"Unit\", \"Entry\" FROM \"" + databaseTable + "\" ORDER BY \"ChecklistId\", \"Unit\", \"Entry\""; 
        
        System.out.print( sql );

        java.sql.Connection con;
        java.sql.Statement  s;
        java.sql.ResultSet  res;
        
        acceptedIdVector = new java.util.Vector();
        idVector = new java.util.Vector();
        
        try
        {
            Class.forName( "org.postgresql.Driver" );
            System.out.println( "Load PostgreSQL Driver..." );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            System.out.println( "ClassNotFoundException: " );
            System.out.println( ee.getMessage() );
        }
        try
        {
            con = java.sql.DriverManager.getConnection( db_url, db_user, db_pwd );
            
            s = con.createStatement();
            res = s.executeQuery( sql );

            int counter = 0;
            int id;
            int checklistId;
            int unit;
            int entry;
            
            int acceptedId = 0;
            
            while( res.next() )
            {
                // id
                id = res.getInt( 1 );                
                // Checklist_Id
                checklistId = res.getInt( 2 );
                // unit
                unit = res.getInt( 3 );                
                // entry
                entry = res.getInt( 4 );
                // System.out.println( counter++ + ", " +id + ", " + checklistId + ", " + unit + ", " + entry );
                
                if( entry == 1 )
                {
                    acceptedId = id;
                    idVector.add( new Integer( acceptedId ) );
                    acceptedIdVector.add(  new Integer( acceptedId ) );
                    // System.out.println( counter++ + ", " +id + ", " + checklistId + ", " + unit + ", " + entry );
                }
                else
                {
                    idVector.add(  new Integer( id ) );
                    acceptedIdVector.add( new Integer( acceptedId ) );
                }
            }
            // Insert Accepted TaxonID
            for( int i = 0; i < idVector.size(); i++ )
            {
                int iid  = ((Integer) idVector.get( i )).intValue();
                int aid = ((Integer) acceptedIdVector.get( i )).intValue();
                if( iid != aid )
                {
                    // System.out.println( "Insert AcceptedNameID : " + iid + ",  " + aid );
                }
                sql = "UPDATE \"checklists_data\" SET \"AcceptedNameID\" = " + aid + " WHERE \"id\" = " + iid;                
                s.executeUpdate( sql );
            }
            con.close();
        }            
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getMessage() );             
        }
        
    }
    //--------------------------------------------------------------------------
    public static void main(String[] args)
    {
        // only for testing
        CreateAcceptedTaxonID catid = new CreateAcceptedTaxonID();
        
        
    }

}
