/*
 * CharacterStateElement.java
 *
 * Created on 13. Februar 2004, 19:14
 */

package net.metadiversity.diversity.navigator.db.delta_editor;

import org.apache.log4j.Logger;
/**
 *
 * @author  didi
 */
public class CharacterStateElement
{
    static Logger logger = Logger.getLogger( CharacterStateElement.class.getName() ); 

    public final static String  TYPE_STRING_RN = "RN";  // real number
    public final static String  TYPE_STRING_UM = "UM";  // unordert Multistate
    public final static String  TYPE_STRING_IN = "IN";  // integer number
    public final static String  TYPE_STRING_OM = "OM";  // orderd multistat
    public final static String  TYPE_STRING_TE = "TE";  // text element
    
    public final static int     TYPE_UNKOWN = 0x0000;
    public final static int     TYPE_RN     = 0x0001;
    public final static int     TYPE_UM     = 0x0002;
    public final static int     TYPE_IN     = 0x0004;
    public final static int     TYPE_OM     = 0x0008;    
    public final static int     TYPE_TE     = 0x0010;
    
    
    private boolean selected;
    private String  type;
    private String  name;
    //------------------------------------------------------------------
    public CharacterStateElement( String type, String name )
    {
        this.selected = false;
        this.type = type;
        this.name = name;
    }
    //------------------------------------------------------------------
    public CharacterStateElement( boolean selected, String type, String name )
    {
        this.selected = selected;
        this.type = type;
        this.name = name;
    }           
    //------------------------------------------------------------------
    public void setSelected( boolean b )
    {
        selected = b;
    }
    //------------------------------------------------------------------
    public Boolean isSelected()
    {
        if( selected )
            return Boolean.valueOf( true  );
        else
            return Boolean.valueOf( false );
    }
    //------------------------------------------------------------------
    public String getName()
    {
        return name;
    }            
    //------------------------------------------------------------------
    public String getTypeString()
    {
        return type;
    }
    //------------------------------------------------------------------
    /*
    public int getType()
    {
        return type;
    }
     */
}
