/*
 * CollectionTabIndentification.java
 *
 * Created on 15. September 2004, 11:39
 */

package net.metadiversity.diversity.navigator.gui;

import com.jgoodies.forms.layout.*;
/**
 *
 * @author  didi
 */
public class CollectionTabIndentification_1 
{
    // form format strings
    String columnFormatString;
    String rowFormatString;
    
    com.jgoodies.forms.layout.FormLayout        layout;
    com.jgoodies.forms.builder.PanelBuilder     builder;
    com.jgoodies.forms.layout.CellConstraints   constraints;
    // default format values
    static final String DEFAULT_COLUMNE_FORMAT = "fill:d:grow";
    static final String PAD_COLUMNE_FORMAT     = "fill:1dlu:nogrow";
    static final String DEFAULT_ROW_FORMAT     = "fill:d:nogrow";
    static final String PAD_ROW_FORMAT         = "fill:2dlu:nogrow";    
    // Form parameter
    int xFormPos;
    int yFormPos;
    int xMaxFormPos;
    int yMaxFormPos;
    // debug
    static boolean DEBUG_ADD_COMPONENT = false;
    
    /** Creates new form CollectionTabIndentification */
    public CollectionTabIndentification_1()
    {
        // initComponents();

        rowFormatString    = "";
        xFormPos = 1;
        xMaxFormPos = 0;
        yFormPos = 1;
        yMaxFormPos = 0;
        
//        columnFormatString = PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +
//                             PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +  
        columnFormatString = PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             // date
                             PAD_COLUMNE_FORMAT + ", " + "fill:10dlu:nogrow" + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:10dlu:nogrow" + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:20dlu:nogrow" + ", " +  
                             // Suppl.
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             // category
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             // Category
                             // PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +  
                             // PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +  
                             // PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +  
                             // PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " + 
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(1.0)" + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(0.2)" + ", " +  
                             // Exsiccatum
                             PAD_COLUMNE_FORMAT + ", " + "fill:10dlu:nogrow" + ", " +  
//                             PAD_COLUMNE_FORMAT + ", " + DEFAULT_COLUMNE_FORMAT + ", " +  
                             PAD_COLUMNE_FORMAT + ", " + "fill:d:grow(1.0)" + ", " +  
                             PAD_COLUMNE_FORMAT 
                            ;
        xMaxFormPos = 13;
        
        createPanel();     
        
        nextRow();
        addLabel( "Taxonomic group:", 0, 0, 1 );
        addComboBox(  1, 0, 1 );        
        // Date ( 7 fields )
        addLabel( "", 1, 0, 6);
        addLabel( "Typified taxon and state:", 1, 0, 2 );
        addTextField( 1, 0, 2 );
        addComboBox(  1, 0, 1 );        
        
        nextRow();
        addLabel( "Taxonomic Name", 0, 0, 1 );
        addLabel( "Vernacular Name", 1, 0, 1 );        
        // Date ( 7 fields )
        addLabel( "Date (dd|mm|yyyy", 1, 0, 3);
        // Label( "/", 1, 0, 1);
        addLabel( "Supl.", 1, 0, 1);
        // Label( "/", 1, 0, 1);
        addLabel( "category)", 1, 0, 1);
        addLabel( "Category", 1, 0, 1 );
        addLabel( "Qualifier", 1, 0, 1 );
        addLabel( "Literature used", 1, 0, 1 );
        addLabel( "Responsible", 1, 0, 1 );
        addLabel( "Exsiccatum", 1, 0, 1 );
        addLabel( "Notes", 1, 0, 1 );
        //----------------------------------------------------------------------
        // line 1
        //--------
        nextRow();
        // Taxonomic name
        addComboBox(  0, 0, 1 );  
        // Vernacular Name
        addTextField( 1, 0, 1 );
        // Date ( 7 fields )
        addTextField( 1, 0, 1 );
        addTextField( 1, 0, 1 );
        addTextField( 1, 0, 1 );
        // Label( "/", 1, 0, 1 );
        addTextField( 1, 0, 1 );
        // Label( "/", 1, 0, 1 );        
        addComboBox(  1, 0, 1 ); 
        // Category
        addComboBox(  1, 0, 1 );        
        // Qualifier
        addComboBox(  1, 0, 1 );        
        // Literature used
        addTextField( 1, 0, 1 );
        // addLabel( "*", 1, 0, 1 );
        // Responsible
        addComboBox(  1, 0, 1 );        
        // Exsiccatum
        addCheckBox(  1, 0, 1 );        
        // Notes
        addTextField( 1, 0, 1 );
        //
        // addLabel( "*", 1, 0, 1 );
        
        //----------------------------------------------------------------------
        // line 2
        //--------
        nextRow();
        // Taxonomic name
        addComboBox(  0, 0, 1 );  
        // Vernacular Name
        addTextField( 1, 0, 1 );
        // Date ( 7 fields )
        addTextField( 1, 0, 1 );
        addTextField( 1, 0, 1 );
        addTextField( 1, 0, 1 );
        // Label( "/", 1, 0, 1 );
        addTextField( 1, 0, 1 );
        // Label( "/", 1, 0, 1 );        
        addComboBox(  1, 0, 1 ); 
        // Category
        addComboBox(  1, 0, 1 );        
        // Qualifier
        addComboBox(  1, 0, 1 );        
        // Literature used
        addTextField( 1, 0, 1 );
        // addLabel( "*", 1, 0, 1 );
        // Responsible
        addComboBox(  1, 0, 1 );        
        // Exsiccatum
        addCheckBox(  1, 0, 1 );        
        // Notes
        addTextField( 1, 0, 1 );
        //
        // addLabel( "*", 1, 0, 1 );
        
        nextRow();
        addLabel( "Colonized part", 0, 0, 1 );
        addTextField( 1, 0, 1 );

        // nextRow();
        addLabel( "growing / living on", 1, 0, 4 );
        addComboBox( 1, 0, 1 );

//        nextRow();
        addLabel( "", 1, 0, 1 );
        addLabel( "Life state", 1, 0, 1 );
        addTextField( 1, 0, 1 );

        addLabel( "Only observed", 1, 0, 1 );
        addCheckBox(  1, 0, 1 );        
        
        nextRow();
        addLabel( "Notes", 1, 0, 1 );
        addTextField( 1, 0, 12 );
        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void debug( int x, int y, int l, int h )
    {
        System.out.println( "x: " + x +  " \ty: " + y + " \tl:" + l );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public javax.swing.JPanel getPanel()
    {
        return builder.getPanel();        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private String pos( int x, int y )
    {
        return "";
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private int calX() 
    { 
        return 2 * xFormPos; 
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private int calY() 
    { 
        return 2 * yFormPos; 
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private int calL( int l ) 
    { 
        return 2 * l -1; 
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private int calSize( int l )
    {
        return l;
    }    
    //--------------------------------------------------------------------------
    // add component to form 
    //--------------------------------------------------------------------------
    public void add( javax.swing.JComponent component, int length )
    {        
        calLayout( length, 0 );        
        constraints.xywh( calX(), calY(), calL( length ), 1 );        
        if( DEBUG_ADD_COMPONENT ) debug( calX(), calY(), calL( length ), 1 );                
        builder.add( component, constraints );                
        xFormPos += calSize( length );                               
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void addLabel( String label, int xRel, int yRel, int l )
    {        
        calLayout( l, 0 );        
        constraints.xywh( calX(), calY(), calL( l ), 1 );        
        if( DEBUG_ADD_COMPONENT ) debug( calX(), calY(), calL( l ), 1 );        
        
        builder.addLabel( label, constraints );        
        
        xFormPos += calSize( l );                               
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void addTextField( int xRel, int yRel, int l )
    {        
        calLayout( l, 0 );        
        constraints.xywh( calX(), calY(), calL( l ), 1 );        
        if( DEBUG_ADD_COMPONENT ) debug( calX(), calY(), calL( l ), 1 );        
        
        javax.swing.JTextField tf = new javax.swing.JTextField();
        builder.add( tf, constraints );        
        
        xFormPos += calSize( l );                       
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void addComboBox( int xRel, int yRel, int l )
    {        
        calLayout( l, 0 );        
        constraints.xywh( calX(), calY(), calL( l ), 1 );        
        if( DEBUG_ADD_COMPONENT ) debug( calX(), calY(), calL( l ), 1 );        
        
        javax.swing.JComboBox cb = new javax.swing.JComboBox();
        builder.add( cb, constraints );        
        
        xFormPos += calSize( l );                       
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void addCheckBox( int xRel, int yRel, int l )
    {        
        calLayout( l, 0 );        
        constraints.xywh( calX(), calY(), calL( l ), 1 );        
        if( DEBUG_ADD_COMPONENT ) debug( calX(), calY(), calL( l ), 1 );        
        
        javax.swing.JCheckBox cb = new javax.swing.JCheckBox();
        builder.add( cb, constraints );        
        
        xFormPos += calSize( l );                       
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    private void nextRow()
    {
        xFormPos = 1;
        yFormPos++;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void calLayout( int w, int h )
    {
        if( xFormPos + w > xMaxFormPos ) 
        {
            for( int i = xMaxFormPos; i < xFormPos + w -1; i++ ) // ??? -1
            {                
                com.jgoodies.forms.layout.ColumnSpec cs = new com.jgoodies.forms.layout.ColumnSpec( DEFAULT_COLUMNE_FORMAT );              
                layout.appendColumn( cs );                                
                // fill:3dlu:nogrow                
                cs = new com.jgoodies.forms.layout.ColumnSpec( PAD_COLUMNE_FORMAT );              
                layout.appendColumn( cs );                
                
                xMaxFormPos++;
            }
            // xMaxFormPos = xFormPos + w - 1;
        }
        if( yFormPos + h > yMaxFormPos ) 
        {
            for( int i = yMaxFormPos; i < yFormPos + h; i++ )
            {                
                com.jgoodies.forms.layout.RowSpec rs = new com.jgoodies.forms.layout.RowSpec( DEFAULT_ROW_FORMAT );              
                layout.appendRow( rs );                
                // fill
                rs = new com.jgoodies.forms.layout.RowSpec( PAD_ROW_FORMAT );              
                layout.appendRow( rs );                                
                
                yMaxFormPos++;
            }
            // yMaxFormPos = yFormPos + h -1;
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void createPanel()
    {
        layout = new com.jgoodies.forms.layout.FormLayout( columnFormatString, rowFormatString );
        builder = new com.jgoodies.forms.builder.PanelBuilder( layout );
        constraints = new com.jgoodies.forms.layout.CellConstraints();
        // first space
        com.jgoodies.forms.layout.ColumnSpec cs = new com.jgoodies.forms.layout.ColumnSpec( PAD_COLUMNE_FORMAT );              
        layout.appendColumn( cs );                
        //
        com.jgoodies.forms.layout.RowSpec rs = new com.jgoodies.forms.layout.RowSpec( PAD_ROW_FORMAT );              
        layout.appendRow( rs );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void setLayout( java.awt.LayoutManager lm )
    {
        
    }
    
    /** This method is called from within the constructor to     
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        
        setLayout(new java.awt.BorderLayout());
        
    }//GEN-END:initComponents
    
    public static void main( String [] args  )
    {
        CollectionTabIndentification_1 p = new CollectionTabIndentification_1();
        
        javax.swing.JFrame f = new javax.swing.JFrame();        
        f.getContentPane().add( p.getPanel() );
        f.setVisible( true );
        f.setDefaultCloseOperation( f.DISPOSE_ON_CLOSE );
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    
}
